/**
 * @file
 * The commercetools_content ajax functionality.
 */

(() => {
  Drupal.behaviors.commercetoolsContentAutoSubmit = {
    attach(context) {
      // Submit the form if there are any changes to the form.
      const forms = once(
        'commercetoolsContentAutoSubmit',
        '.commercetools-content-auto-submit',
        context,
      );
      forms.forEach((form) => {
        form.addEventListener('input', () => {
          form.requestSubmit();
        });
      });

      // Hide submit button for auto submit form.
      const jsHiddenElement = once(
        'commercetoolsContentAutoSubmit',
        '.js-hidden',
        context,
      );
      jsHiddenElement.forEach((el) => {
        el.style.display = 'none';
      });
    },
  };
})();
