class InputEmail extends HTMLElement {
  connectedCallback() {
    const { name, label, disabled, defaultValue, required } = this.properties;
    const selector = name.replace(/\[(.*?)\]/g, '-$1');

    this.innerHTML = `
      <div class="form-item form-type-email form-item-${selector}">
        <label for="edit-${selector}" class="${required ? 'form-required' : ''}">${label}</label>
        <input type="email" id="edit-${selector}" name="${name}" value="${defaultValue}" size="60" maxlength="254" ${disabled ? 'disabled="disabled"' : ''} ${required ? 'required="required"' : ''} class="form-email form-control ${required ? 'required' : ''}">
      </div>
    `;
  }
}

customElements.define('ct-input-email', InputEmail);
