class ProductList extends HTMLElement {
  connectedCallback() {
    const container = document.createElement('div');
    container.classList.add('container', 'commercetools-product-cards');
    const row = document.createElement('div');
    row.classList.add('row');
    container.appendChild(row);

    this.innerHTML = '';
    this.renderProducts(row).catch((error) => {
      new Drupal.Message().add(
        Drupal.t('An error occurred while loading products.'),
        {
          type: 'error',
        },
      );
      throw error;
    });

    this.appendChild(container);
  }

  async renderProducts(row) {
    row.innerHTML = '';
    const columnClass = !this.showFilters ? 'col-lg-3' : 'col-lg-4';
    this.products.forEach((product) => {
      const productWrapper = document.createElement('div');
      productWrapper.classList.add(
        'col-12',
        'col-md-6',
        'my-2',
        'ps-0',
        columnClass,
      );
      const productCard = document.createElement('ct-product-card');
      productCard.product = product;
      productCard.isLoading = this.isLoading;
      productWrapper.appendChild(productCard);
      row.appendChild(productWrapper);
    });
  }
}

customElements.define('ct-product-list', ProductList);
