class OrderInfo extends HTMLElement {
  async connectedCallback() {
    const orderId = this.getAttribute('order-id');

    this.isLoading = true;
    this.order = null;

    this.renderComponent();

    try {
      const response = await window.commercetools.getOrders(
        {
          where: `id="${orderId}" and customerId="[current_customer:id]"`,
        },
        true,
      );
      [this.order] = response.orders;

      if (!this.order) {
        this.renderNotFound();
      }
    } finally {
      this.isLoading = false;
      this.renderComponent();
    }
  }

  renderNotFound() {
    this.innerHTML = '';
    const notFound = document.createElement('ct-page-not-found');
    this.appendChild(notFound);
  }

  renderComponent() {
    const container = document.createElement('ct-order-details');
    container.isLoading = this.isLoading;
    container.order = this.order;
    this.innerHTML = '';
    this.appendChild(container);
  }
}

customElements.define('ct-order-info', OrderInfo);
