/**
 * Deploys the demo configuration for a Commercetools UI module.
 *
 * @param {object} browser
 *   Nightwatch browser instance.
 * @param {string} module
 *   A module name to deploy.
 */
module.exports = function deployDemoModule(browser, module) {
  browser
    .thLogin('admin')
    .drupalRelativeURL('/admin/config/system/commercetools/demo')
    .thSetConfig('system.theme', { admin: 'stark' })
    .click(`input[name=set_theme_bootstrap]`)
    .click(`input[name=install_${module}]`)
    .assert.textContains('body', 'Installed with demo configuration')
    .thLogout();
};
