const shopSmokeTest = require('../../../../../../tests/src/Nightwatch/Lib/shopSmokeTest');
const deployDemoModule = require('./deployDemoModule');

/**
 * Performs a smoke test for the demo functionality.
 *
 * @param {object} browser
 *   Nightwatch browser instance.
 * @param {string} module
 *   A module name to deploy.
 */
module.exports = function smokeTestDemo(browser, module) {
  let catalogPrefix;
  if (module === 'commercetools_content') {
    catalogPrefix = 'content';
  } else if (module === 'commercetools_decoupled') {
    catalogPrefix = 'decoupled';
  } else {
    throw new Error(`Unknown module: ${module}`);
  }
  const catalogPath = `/commercetools-demo/${catalogPrefix}/catalog`;
  browser.perform(() => {
    deployDemoModule(browser, module);
    shopSmokeTest(browser, catalogPath);
  });
};
