<?php

namespace Drupal\commercetools\Exception;

use Commercetools\Base\MapperSequence;

/**
 * The exception on an unexpected error with a requests to commercetools API.
 */
class CommercetoolsGraphqlErrorException extends CommercetoolsOperationFailedException {

  /**
   * {@inheritdoc}
   */
  public function __construct(?MapperSequence $errors = NULL, ?string $query = NULL, ?array $variables = NULL, ?int $code = NULL, ?\Throwable $previous = NULL) {
    foreach ($errors as $error) {
      $messages[] = $error->getMessage();
    }
    $message = implode("\n", $messages);
    $code ??= 0;
    parent::__construct($message, $code, $previous);
  }

}
