const addCatalogProductToCart = require('./utils/addCatalogProductToCart');
const checkSummaryLineItem = require('./checkSummaryLineItem');
const { blocks, product } = require('./selectors');

async function checkCartSummaryBlock(browser, items, catalogUrl, settings) {
  const oldCookies = await browser.cookies.getAll();

  await browser
    .drupalRelativeURL(catalogUrl)
    .waitForElementVisible(product.catalog);

  // @todo Make a dynamic check for the card in stock.
  const cardInStockIndex = 4;
  await addCatalogProductToCart(browser, cardInStockIndex);

  await browser
    .drupalRelativeURL(catalogUrl)
    .waitForElementVisible(product.catalog)
    .waitForElementVisible(blocks.summary.component)
    .click(
      browser
        .element({ selector: blocks.summary.component })
        .findElement(blocks.summary.dropdownButton),
    )
    .waitForElementVisible(
      browser
        .element({ selector: blocks.summary.component })
        .findElement(blocks.summary.dropdown),
    );

  await checkSummaryLineItem(browser, items[cardInStockIndex], 0, settings);

  // Delete new cookies created after adding an item to the cart.
  const cookies = await browser.cookies.getAll();
  cookies.forEach((cookie) => {
    if (!oldCookies.some((oldCookie) => cookie.name === oldCookie.name)) {
      browser.cookies.delete(cookie.name);
    }
  });
}

module.exports = checkCartSummaryBlock;
