const checkProductCard = require('./checkProductCard');
const checkEmptyProductList = require('./checkEmptyProductList');
const { product, blocks } = require('./selectors');

async function checkSearchFrom(browser, items, settings) {
  const [first] = items;

  // Search by the first value, there must be at least one result.
  await browser
    .element({ selector: blocks.search.component })
    .findElement(blocks.search.input)
    .setValue(first.name);

  await browser
    .click(
      browser
        .element({ selector: blocks.search.component })
        .findElement(blocks.search.submit),
    )
    .waitForElementVisible(product.card.component);

  await checkProductCard(browser, first, 0, settings);

  // Search for an unknown value, there should be no results.
  await browser
    .element({ selector: blocks.search.component })
    .findElement(blocks.search.input)
    .setValue('[commercetools_test_value]');

  await browser.click(
    browser
      .element({ selector: blocks.search.component })
      .findElement(blocks.search.submit),
  );

  await checkEmptyProductList(browser);

  // Clear the search form after testing.
  await browser
    .element({ selector: blocks.search.component })
    .findElement(blocks.search.input)
    .setValue('');

  await browser
    .click(
      browser
        .element({ selector: blocks.search.component })
        .findElement(blocks.search.submit),
    )
    .waitForElementVisible(product.card.component);
}

module.exports = checkSearchFrom;
